<?

	class TS_Sonos extends IPSModule
	{

		public function __construct($InstanceID)
		{
			//Never delete this line!
			parent::__construct($InstanceID);
			
			//These lines are parsed on Symcon Startup or Instance creation
			//You cannot use variables here. Just static values.
			$this->RegisterPropertyString("IPAddress", "192.168.1.37");
			$this->RegisterPropertyString("Pfad", "192.168.1.11/nas/");
			$this->RegisterPropertyString("Alarm", "alarm-sirene.mp3");
			$this->RegisterPropertyString("Radio1Name", "Radio Lippe");
			$this->RegisterPropertyString("Radio2Name", "FFN");
			$this->RegisterPropertyString("Radio3Name", "FFH");
			$this->RegisterPropertyString("Radio4Name", "OE3");
			$this->RegisterPropertyString("Radio5Name", "Antenne Bayern");
			$this->RegisterPropertyString("Radio1", "x-sonosapi-stream:s96523?sid=254&flags=32&sn=0");
			$this->RegisterPropertyString("Radio2", "x-sonosapi-stream:s8954?sid=254&flags=32&sn=0");
			$this->RegisterPropertyString("Radio3", "x-sonosapi-stream:s17490?sid=254&amp;flags=32");
			$this->RegisterPropertyString("Radio4", "x-rincon-mp3radio://mp3stream7.apasf.apa.at:8000");
			$this->RegisterPropertyString("Radio5", "x-sonosapi-stream:s15030?sid=254&amp;flags=32");
			$this->RegisterPropertyString("DisplayId", "24208");
			$this->RegisterPropertyString("DisplayZeile", "2");

		}

		public function ApplyChanges()
		{
			//Never delete this line!
			parent::ApplyChanges();

			$this->RegisterScript("_Steuerung", "_Steuerung", '<?
      IPS_SetScriptTimer($_IPS[\'SELF\']  , 5);                  // ScriptTimer einschalten (auf 60 Sekunde setzen)
      switch ($_IPS["SENDER"])                                     // Ursache (Absender) des Triggers ermittlen
{
  case "WebFront": //zum ersten Start
      IPS_SetScriptTimer($_IPS[\'SELF\']  , 5);                  // ScriptTimer einschalten (auf 60 Sekunde setzen)
  		IPS_SetHidden(IPS_GetObjectIDByName(\'Radiotitel_alt\', IPS_GetParent($_IPS[\'SELF\'])), true);
	  	IPS_SetHidden(IPS_GetObjectIDByName(\'_Steuerung\', IPS_GetParent($_IPS[\'SELF\'])), true);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Volume\', IPS_GetParent($_IPS[\'SELF\'])), 1);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Bass\', IPS_GetParent($_IPS[\'SELF\'])), 2);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Treble\', IPS_GetParent($_IPS[\'SELF\'])), 3);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Loudness\', IPS_GetParent($_IPS[\'SELF\'])), 4);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Mute\', IPS_GetParent($_IPS[\'SELF\'])), 5);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Radiotitel\', IPS_GetParent($_IPS[\'SELF\'])), 6);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Sender\', IPS_GetParent($_IPS[\'SELF\'])), 7);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Station\', IPS_GetParent($_IPS[\'SELF\'])), 8);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Status\', IPS_GetParent($_IPS[\'SELF\'])), 9);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Sleeptimer\', IPS_GetParent($_IPS[\'SELF\'])), 10);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Alarm_abspielen\', IPS_GetParent($_IPS[\'SELF\'])), 20);
      IPS_SetPosition(IPS_GetObjectIDByName(\'Logo\', IPS_GetParent($_IPS[\'SELF\'])), 30);


  case "TimerEvent":                                     // Timer hat getriggert

$s_radio = GetValueString(IPS_GetObjectIDByName(\'Radiotitel\', IPS_GetParent($_IPS[\'SELF\'])));
$loud = GetValue(IPS_GetObjectIDByName(\'Loudness\', IPS_GetParent($_IPS[\'SELF\'])));
$ip = IPS_GetProperty(IPS_GetParent($_IPS[\'SELF\']), "IPAddress");
if (Sys_Ping($ip, 1000) == true) {
//include("PHPSonos.inc.php");
include("../modules/Ts/TS_Sonos/sonos.php");

$sonos = new PHPSonos($ip); //Sonos ZP IPAdresse
$s_steuer = $sonos->GetTransportInfo();
SetValueInteger(IPS_GetObjectIDByName(\'Status\', IPS_GetParent($_IPS[\'SELF\'])) , $s_steuer);
$s_sleep = $sonos->GetSleeptimer();
SetValueString(IPS_GetObjectIDByName(\'Sleeptimer\', IPS_GetParent($_IPS[\'SELF\']))   , $s_sleep);

$loud = $sonos->GetLoudness();
if ($loud == 1)
{
  SetValueInteger(IPS_GetObjectIDByName(\'Loudness\', IPS_GetParent($_IPS[\'SELF\'])) , 1);
}
if ($loud == 0)
{
  SetValueInteger(IPS_GetObjectIDByName(\'Loudness\', IPS_GetParent($_IPS[\'SELF\'])) , 0);
}

$mute = $sonos->GetMute();
if ($mute == 1)
{
  SetValueInteger(IPS_GetObjectIDByName(\'Mute\', IPS_GetParent($_IPS[\'SELF\']))  , 1);
}
if ($mute == 0)
{
  SetValueInteger(IPS_GetObjectIDByName(\'Mute\', IPS_GetParent($_IPS[\'SELF\'])), 0);
}

$s_vol = $sonos->GetVolume();;
SetValueInteger(IPS_GetObjectIDByName(\'Volume\', IPS_GetParent($_IPS[\'SELF\'])) , $s_vol);

$s_bass = $sonos->GetBass();;
SetValueInteger(IPS_GetObjectIDByName(\'Bass\', IPS_GetParent($_IPS[\'SELF\'])) , $s_bass);

$s_treble = $sonos->GetTreble();;
SetValueInteger(IPS_GetObjectIDByName(\'Treble\', IPS_GetParent($_IPS[\'SELF\'])) , $s_treble);

// Titelanzeige
$posInfo3 = $sonos->GetPositionInfo();
//var_dump($posInfo3);
$posInfo2 = GetValueString(IPS_GetObjectIDByName(\'Radiotitel_alt\', IPS_GetParent($_IPS[\'SELF\']))  );
$posInfo = $posInfo3[\'streamContent\'];
$s_radio = $sonos->GetMediaInfo();
//$s_radio = $s_radio[\'title\'];

//var_dump($s_radio);
if (strlen($posInfo3[\'streamContent\']) != 0) // Für NAS Titel Anzeige

{
$s_radio = $s_radio[\'title\'];
$logo = $sonos->RadiotimeGetNowPlaying();
SetValueString(IPS_GetObjectIDByName(\'Logo\', IPS_GetParent($_IPS[\'SELF\'])) ,\'<img src="\'.$logo[\'logo\'].\'">\');
SetValueString(IPS_GetObjectIDByName(\'Sender\', IPS_GetParent($_IPS[\'SELF\'])) , $s_radio);

}
else
{
$s_radio = "";
}

if ($s_radio == "") 
{
		$s_radio = $sonos->GetPositionInfo();
		$s_radio2 = $s_radio[\'title\'];
      $s_radio3 = $s_radio[\'artist\'];
      $array[0] = "$s_radio2";
	   $array[1] = "|";
	   $array[2] = "$s_radio3";
	   $posInfo = implode("", $array);
//echo ($s_radio);
$posInfo = utf8_decode($posInfo);
}

if ($posInfo == $posInfo2)
{

// mache nichts
}
else
{
$posInfo2=$posInfo;
SetValueString(IPS_GetObjectIDByName(\'Radiotitel\', IPS_GetParent($_IPS[\'SELF\'])) , $posInfo);
SetValueString(IPS_GetObjectIDByName(\'Radiotitel_alt\', IPS_GetParent($_IPS[\'SELF\'])) , $posInfo);
$laenge = strlen($posInfo);
$displayid =IPS_GetProperty(IPS_GetParent($_IPS[\'SELF\']), "DisplayId");
$DisplayId = intval($displayid);
$DisplayZeile = IPS_GetProperty(IPS_GetParent($_IPS[\'SELF\']), "DisplayZeile");

if ($DisplayId != 0)
{
if (strlen($posInfo3[\'streamContent\']) != 0)
{
  $array[0] = "$posInfo";
  $array[1] = " - ";
  $array[2] = "$s_radio";
}
$dyntext = implode("", $array);
$laenge = strlen($dyntext);

$text=utf8_decode(substr($dyntext,0,12));
LCN_SendCommand($DisplayId ,\'GT\',\'DT\'.$DisplayZeile.\'1\'.$text);

$text=utf8_decode(substr($dyntext,12,12));
LCN_SendCommand($DisplayId ,\'GT\',\'DT\'.$DisplayZeile.\'2\'.$text);

$text=utf8_decode(substr($dyntext,24,12));
LCN_SendCommand($DisplayId ,\'GT\',\'DT\'.$DisplayZeile.\'3\'.$text);

$text=utf8_decode(substr($dyntext,36,12));
LCN_SendCommand($DisplayId ,\'GT\',\'DT\'.$DisplayZeile.\'4\'.$text);

$text=utf8_decode(substr($dyntext,48,12));
LCN_SendCommand($DisplayId ,\'GT\',\'DT\'.$DisplayZeile.\'5\'.$text);
}

}
} // if sys_ping
break;}
?>');

$this->RegisterScript("Alarm_abspielen", "Alarm_abspielen", '<? 
$ip = IPS_GetProperty(IPS_GetParent($_IPS[\'SELF\']), "IPAddress");
$pfad = IPS_GetProperty(IPS_GetParent($_IPS[\'SELF\']), "Pfad");
$alarm = IPS_GetProperty(IPS_GetParent($_IPS[\'SELF\']), "Alarm");
if (Sys_Ping($ip, 1000) == true) {
include("../modules/Ts/TS_Sonos/sonos.php");
$sonos = new PHPSonos($ip); //Sonos ZP IPAdresse

$ton="alarm";

$wav = array
(
// x-file-cifs://192.168.1.11/nas/
   "alarm"   => "x-file-cifs://".$pfad.$alarm,
   "bell"    => "x-file-cifs://".$pfad."alarm-sirene.mp3"
);
$volume                         = $sonos->GetVolume();                 

//Speichern der Aktuellen Informationen
$oldpi = $sonos->GetPositionInfo();
$oldmi = $sonos->GetMediaInfo();
$radio=(strpos($oldmi[\'CurrentURI\'],"x-sonosapi-stream:")>0)===false;
$oldti = $sonos->GetTransportInfo();

$sonos->SetVolume(5);
$sonos->SetAVTransportURI($wav[$ton]);
$sonos->Play();

IPS_Sleep(1000);
while ($sonos->GetTransportInfo()==1)
{
    IPS_Sleep(200); //Alle 200ms wird abgefragt
}
//Player wieder Starten
if ($radio)
{
    $sonos->SetRadio($oldmi[\'CurrentURI\']);
}
else
{
    $sonos->SetAVTransportURI($oldmi[\'CurrentURI\'],$oldmi[\'CurrentURIMetaData\']);
}
try
{
    // Seek TRack_Nr
   $sonos->Seek("TRACK_NR",$oldpi[\'Track\']);
   // Seek REl_time
   $sonos->Seek("REL_TIME",$oldpi[\'RelTime\']);
}
catch (Exception $e)
{
}
if ($oldti==1) $sonos->Play();
$sonos->SetVolume($volume);
}
?>');


			$this->RegisterProfileIntegerEx("Status.SONOS", "Information", "", "", Array(
				Array(0, "Prev", "", -1),
				Array(1, "Play", "", -1),
				Array(2, "Pause", "", -1),
				Array(3, "Stop", "", -1),
				Array(4, "Next", "", -1)
			));
			$this->RegisterProfileIntegerEx("Schalter.SONOS", "Information", "", "", Array(
				Array(0, "Off", "", 0xFF0000),
				Array(1, "On", "", 0x00FF00)
			));
			$this->RegisterProfileIntegerEx("Station.SONOS", "Information", "", "", Array(
				Array(0, $this->ReadPropertyString("Radio1Name"), "", -1),
				Array(1, $this->ReadPropertyString("Radio2Name"), "", -1),
				Array(2, $this->ReadPropertyString("Radio3Name"), "", -1),
				Array(3, $this->ReadPropertyString("Radio4Name"), "", -1),
				Array(4, $this->ReadPropertyString("Radio5Name"), "", -1),
			));
			$this->RegisterProfileInteger("Volume.SONOS", "Intensity", "", " %", 0, 100, 1);
			$this->RegisterProfileInteger("Klang.SONOS", "Intensity", "", " %", -10, 10, 1);
		
			$this->RegisterVariableInteger("Status", "Status", "Status.SONOS");
			$this->EnableAction("Status");
			$this->RegisterVariableInteger("Volume", "Volume", "Volume.SONOS");
			$this->EnableAction("Volume");
			$this->RegisterVariableInteger("Bass", "Bass", "Klang.SONOS");
			$this->EnableAction("Bass");
			$this->RegisterVariableInteger("Treble", "Treble", "Klang.SONOS");
			$this->EnableAction("Treble");
			$this->RegisterVariableInteger("Loudness", "Loudness", "Schalter.SONOS");
			$this->EnableAction("Loudness");
			$this->RegisterVariableInteger("Mute", "Mute", "Schalter.SONOS");
			$this->EnableAction("Mute");
			$this->RegisterVariableInteger("Station", "Station", "Station.SONOS");
			$this->EnableAction("Station");
			$this->RegisterVariableString("Radiotitel", "Radiotitel", "");
			$this->RegisterVariableString("Radiotitel_alt", "Radiotitel_alt", "");
 			$this->RegisterVariableString("Sleeptimer", "Sleeptimer", "");
 			$this->RegisterVariableString("Sender", "Sender", "");
 			$this->RegisterVariableString("Logo", "Logo", "~HTMLBox");

		}

		/**
		* This function will be available automatically after the module is imported with the module control.
		* Using the custom prefix this function will be callable from PHP and JSON-RPC through:
		*
		* SNS_Play($id);
		*
		*/
		public function Play()
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->Play();
			}
		}
		
		public function Pause()
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->Pause();
      } 			
		}
		public function Stop()
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->Stop();
			}
		}
		
		public function Previous()
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->Previous();
			}
		}
		
		public function Next()
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->Next();
			}
		}
		
		public function SetVolume($volume)
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->SetVolume($volume);
			}
		}
		public function SetBass($bass)
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->SetBass($bass);
			}
		}
		public function SetTreble($treble)	
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->SetTreble($treble);
			}
		}

		public function SetMute($mute)	
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->SetMute($mute);
			}
		}

		public function SetLoudness($loudness)	
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->SetLoudness($loudness);
			}
		}
		public function SetRadio($radio)	
		{
      if (Sys_Ping($this->ReadPropertyString("IPAddress"), 1000) == true) {		
			include(__DIR__ . "/sonos.php");
			(new PHPSonos($this->ReadPropertyString("IPAddress")))->SetRadio($radio);
			}
		}

		
		
		public function RequestAction($Ident, $Value)
		{
			switch($Ident) {
				case "Station":
					switch($Value) {
						case 0: 
							$this->SetRadio($this->ReadPropertyString("Radio1"),"");
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 1: 
							$this->SetRadio($this->ReadPropertyString("Radio2"),"");
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 2: 
							$this->SetRadio($this->ReadPropertyString("Radio3"),"");
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 3: 
							$this->SetRadio($this->ReadPropertyString("Radio4"),"");
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 4: 
							$this->SetRadio($this->ReadPropertyString("Radio5"),"");
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;

					}
					break;
				case "Status":
					switch($Value) {
						case 0: //Prev
							$this->Previous();
							break;
						case 1: //Play
							$this->Play();
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 2: //Pause
							$this->Pause();
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 3: //Stop
							$this->Stop();
							SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 4: //Next
							$this->Next();
							break;
					}
					break;
				case "Volume":
					$this->SetVolume($Value);
					SetValue($this->GetIDForIdent($Ident), $Value);
					break;
				case "Bass":
					$this->SetBass($Value);
					SetValue($this->GetIDForIdent($Ident), $Value);
					break;
				case "Treble":
					$this->SetTreble($Value);
					SetValue($this->GetIDForIdent($Ident), $Value);
					break;
				case "Mute":
					$this->SetMute($Value);
					SetValue($this->GetIDForIdent($Ident), $Value);
					break;
				case "Loudness":
					switch($Value) {
						case 0: //Off
    					$this->SetLoudness($Value);
    					SetValue($this->GetIDForIdent($Ident), $Value);
							break;
						case 1: //On
    					$this->SetLoudness($Value);
    					SetValue($this->GetIDForIdent($Ident), $Value);
							break;
					}
					break;

				default:
					throw new Exception("Invalid ident");
			}
		
		}
		
		//Remove on next Symcon update
		protected function RegisterProfileInteger($Name, $Icon, $Prefix, $Suffix, $MinValue, $MaxValue, $StepSize) {
		
			if(!IPS_VariableProfileExists($Name)) {
				IPS_CreateVariableProfile($Name, 1);
			} else {
				$profile = IPS_GetVariableProfile($Name);
				if($profile['ProfileType'] != 1)
					throw new Exception("Variable profile type does not match for profile ".$Name);
			}
			
			IPS_SetVariableProfileIcon($Name, $Icon);
			IPS_SetVariableProfileText($Name, $Prefix, $Suffix);
			IPS_SetVariableProfileValues($Name, $MinValue, $MaxValue, $StepSize);
			
		}
		
		protected function RegisterProfileIntegerEx($Name, $Icon, $Prefix, $Suffix, $Associations) {
		
			$this->RegisterProfileInteger($Name, $Icon, $Prefix, $Suffix, $Associations[0][0], $Associations[sizeof($Associations)-1][0], 0);
		
			foreach($Associations as $Association) {
				IPS_SetVariableProfileAssociation($Name, $Association[0], $Association[1], $Association[2], $Association[3]);
			}
			
		}
		
	
	}

?>
